from time import sleep
from .Frames_capture_fixture import FixtureFramesCapture, EthProtocolType, BusType
from xtr import logging, Severity
logger = logging.getLogger(__name__)


# Create the test case class, that inherits from the preset TestFixture.
class TestCapturePTPMessage(FixtureFramesCapture):

    # This method will be executed just before
    # the test case method execution.
    def setUp(self):
        logger.info("Setup test case")

    # This method will be executed just after
    # the test case method execution.
    def tearDown(self):
        logger.info("Tear down test case")

# Create the test case core method that holds the main test steps.
    def test_capture_ptp_message(self):
        expected_list =[{'message_id': '2', 'message_type': 'PDelayReq'}, {'message_id': '2', 'message_type': 'PDelayReq'}]
        self.bus_manager.ethernet_listener(bus_name="Ethernet_MTF",protocol=EthProtocolType.IS_PTP).start_listening()
        ptp_msg_payload = "01 00 5e 00 00 00 70 b3 d5 4c 1b 4d 20 90 00 60 8e 67 03 03 00 80 00 00 00 0f 00 00 00 b3 00 08 c9 10 f1 b1 27 10 00 40 00 00 01 80 c2 00 00 0e a8 40 0b 07 28 90 88 f7 10 02 00 2c 00 00 02 08 00 00 00 00 00 00 00 00 00 00 00 00 a8 40 0b ff fe 07 28 90 00 03 ae ce 00 fd 00 00 00 00 00 00 00 00 00 00 07 7d 5e d9 a2 54"

        msg = self.bus_manager.create_ethernet_message(EthProtocolType.IS_PTP)

        msg.set_bytes(bytearray.fromhex(ptp_msg_payload))
        # msg.send()
        data=[0x01,0x80,0xc2,0x00,0x00,0x0e,0x00,0x80,0x63,0x00,0x09,0xba,0x88,
              0xf7,0x02,0x02,0x00,0x36,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
              0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x63,0xff,0xff,
              0x00,0x09,0xba,0x00,0x02,0x04,0x5e,0x05,0x0f,0x00,0x00,0x45,0xb1,
              0x11,0x49,0x1c,0x41,0x78,0xf4,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
              0x00,0x00,0x00]

        self.bus_manager.bus_transmitter(BusType.ETHERNET).transmit_frame("Ethernet_MTF",data)

        sleep(0.1)
        self.bus_manager.ethernet_listener(bus_name="Ethernet_MTF",
                                           protocol=EthProtocolType.IS_PTP).stop_listening()
        messages = self.bus_manager.ethernet_listener(bus_name="Ethernet_MTF",
                                                      protocol=EthProtocolType.IS_PTP).get_queue()

        actual_ptp = []

        for message in messages:
            dict_ptp ={}
            dict_ptp["message_id"]= str(message["ptp_message"].message_id)
            dict_ptp["message_type"]= str(message["ptp_message"].message_type)
            actual_ptp.append(dict_ptp)

        self.assertEqual(actual_ptp,
                         expected_list,
                         Severity.BLOCKER)
